BEGIN{
	printf("#include \"%s_tests.hh\"\n", CLASS);
	#printf("#include \"%s\"\n", MAIN);
	printf("#include \"t/main.hh\"\n");
	printf("#include <memory>\n\n");
	#CLASS=substr(HEAD, 0, index("_tests.hh", HEAD));
	CLASS=CLASS "_tests";

	printf("using namespace std;\n\n");
	printf("class %s: public tester {\n\tpublic:\n\t\t%s(int s, int l): tester(s,l) {};\n", CLASS, CLASS);
	printf("\t\tvoid normal_test() {\n");

	INIT="\t\tvoid init() {}\n";
	CLEANUP="\t\tvoid cleanup() {}\n";
	PERFHEAD="\t\tvoid run_perf() {\n";
	PERF = "";
	PERFTAIL = "";

	SINGLEPERFHEAD="\t\tvoid run_single_perf(int i) {\n";
	SINGLEPERF="\t\t\tswitch(i) {\n\t\t\t\tcase 0: run_perf();\n";
	SINGLEPERFTAIL="";

	PERFCNT=0;
	SINGLEPERFNAME="\t\tchar* get_single_perf_name(int i) {\n\t\t\tswitch(i) {\n\t\t\t\tcase 0: return \"all\";\n";
}
/^void TEST_/{
	FUNC=substr($2,0,length($2)-2);
	print("\t\t\ttest_it(" FUNC ", \"" $2 "\");");
}
/^void INIT_/{
	FUNC=substr($2,0,length($2)-2);
	INIT=sprintf("\t\tvoid init() {\n\t\t\ttest_it(" FUNC ", \"" $2 "\");\n\t\t}\n");
	#PERFHEAD = sprintf("%s\t\t\ttest_it(" FUNC ", \"" $2 "\");\n", PERFHEAD);	
	#SINGLEPERFHEAD = sprintf("%s\t\t\ttest_it(" FUNC ", \"" $2 "\");\n", SINGLEPERFHEAD);	
}
/^void CLEANUP_/{
	FUNC=substr($2,0,length($2)-2);
	CLEANUP=sprintf("\t\tvoid cleanup() {\n\t\t\ttest_it(" FUNC ", \"" $2 "\");\n\t\t}\n");
	#PERFTAIL = sprintf("\t\t\ttest_it(" FUNC ", \"" $2 "\");%s", PERFTAIL);	
	#SINGLEPERFTAIL = sprintf("\t\t\ttest_it(" FUNC ", \"" $2 "\");%s", SINGLEPERFTAIL);	
}
/^void EPERF_/{
	FUNC=substr($2,0,length($2)-2);
	PERF=sprintf("%s\t\t\ttest_it(" FUNC ", \"" $2 "\");\n", PERF);
	PERFCNT++;
	SINGLEPERF=sprintf("%s\t\t\t\tcase %d: test_it(%s, \"%s\"); break;\n", SINGLEPERF, PERFCNT, FUNC, FUNC);
	SINGLEPERFNAME=sprintf("%s\t\t\t\tcase %d: return \"%s\"; break;\n", SINGLEPERFNAME, PERFCNT, substr(FUNC, 7));
}
/^void TEST_PERF_/{
	FUNC=substr($2,0,length($2)-2);
	PERF=sprintf("%s\t\t\ttest_it(" FUNC ", \"" $2 "\");\n", PERF);
	PERFCNT++;
	SINGLEPERF=sprintf("%s\t\t\t\tcase %d: test_it(%s, \"%s\"); break;\n", SINGLEPERF, PERFCNT, FUNC, FUNC);
	SINGLEPERFNAME=sprintf("%s\t\t\t\tcase %d: return \"%s\"; break;\n", SINGLEPERFNAME, PERFCNT, substr(FUNC, 11));
}

END{
	print("\t\t}\n");
	print(INIT);
	print(PERFHEAD);
	print(PERF);
	print(PERFTAIL);
	print("\t\t}\n");
	print(SINGLEPERFHEAD);
	print(SINGLEPERF);
	print("\t\t\t};\n");
	print(SINGLEPERFTAIL);
	print("\t\t}\n");
	print(SINGLEPERFNAME);
	print("\t\t\t};\n");
	print("\t\t\treturn \"ukn\";\n");
	print("\t\t}");
	print(CLEANUP);

	printf("\t\tint getSinglePerfTests() { return %d;}\n", PERFCNT);
	print("};\n");
	printf("auto_ptr<tester> getTester(int s, int l) { auto_ptr<tester> t(new %s(s,l)); return t; }\n", CLASS);
}

